import { Base, Point, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "./type";
import { DomRenderer, DomWrapper } from "./dom";
import { IExecutionContext } from "./IExecutionContext";
import { CanvasGestureDOMEventProxy } from "./CanvasGestureDOMEventProxy";
import { Brush } from "./Brush";
import { Key } from "./Key";
import { DoubleAnimator } from "./DoubleAnimator";
import { ScrollbarStyle } from "./ScrollbarStyle";
import { IScrollerKeyboardListener } from "./IScrollerKeyboardListener";
import { ScrollerScrollingEventArgs } from "./ScrollerScrollingEventArgs";
/**
 * @hidden
 */
export declare class ScrollerView extends Base {
    static $t: Type;
    constructor(a: Scroller);
    c: Scroller;
    protected ad: DomRenderer;
    protected ah: DomWrapper;
    protected b: IExecutionContext;
    a8(): Brush;
    protected ac: HTMLDivElement;
    protected a: CanvasGestureDOMEventProxy;
    ag: DomWrapper;
    ae: DomWrapper;
    af: DomWrapper;
    ai: DomWrapper;
    a0(a: any): void;
    private k;
    private r;
    private ak;
    private al;
    private am;
    private p;
    private q;
    private n;
    private o;
    private e;
    private j;
    ay(a: number): void;
    az(a: number): void;
    av(a: number): void;
    aw(a: number): void;
    aj(): void;
    private an;
    private ao;
    a6(a: number): void;
    private ap;
    z(): number;
    aa(): number;
    private l;
    private m;
    private aq;
    a5(a: number): void;
    a1(a: any): void;
    private d;
    a2(a: () => void): void;
    private i;
    private h;
    private w;
    private t;
    private x;
    private u;
    private g;
    private f;
    private v;
    private s;
    at(): void;
    as(): void;
    a7(a: number, b: number): void;
    a3(a: number, b: number): void;
    a4(a: boolean): void;
    private y;
    private ab;
    ar(): void;
    ax(): void;
    au(): void;
}
/**
 * @hidden
 */
export declare class Scroller extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private a9;
    get smallVerticalChange(): number;
    set smallVerticalChange(a: number);
    private _keyboardListener;
    get keyboardListener(): IScrollerKeyboardListener;
    set keyboardListener(a: IScrollerKeyboardListener);
    private a1;
    get largeVerticalChange(): number;
    set largeVerticalChange(a: number);
    private av;
    get bi(): number;
    set bi(a: number);
    private at;
    get bg(): number;
    set bg(a: number);
    private a8;
    get smallHorizontalChange(): number;
    set smallHorizontalChange(a: number);
    private a0;
    get largeHorizontalChange(): number;
    set largeHorizontalChange(a: number);
    private au;
    get bh(): number;
    set bh(a: number);
    private as;
    get bf(): number;
    set bf(a: number);
    private ay;
    get contentWidth(): number;
    set contentWidth(a: number);
    private a2;
    get minScrollbarSize(): number;
    set minScrollbarSize(a: number);
    private a5;
    get scrollbarSpan(): number;
    set scrollbarSpan(a: number);
    ai(a: Key, b: boolean, c: boolean): boolean;
    private ao;
    private af;
    private ah;
    private an;
    private aj;
    private ap;
    private ae;
    private am;
    private al;
    private ag;
    private bb;
    get verticalTrackStartInset(): number;
    set verticalTrackStartInset(a: number);
    private dp;
    get scrollbarBrush(): Brush;
    set scrollbarBrush(a: Brush);
    private c8;
    private v;
    private get aq();
    private set aq(value);
    protected db(a: string, b: any, c: any): void;
    private ax;
    get contentHeight(): number;
    set contentHeight(a: number);
    c9(a: number): void;
    c7(a: number): void;
    da(a: number, b: number, c?: boolean): void;
    private bd;
    get viewportWidth(): number;
    set viewportWidth(a: number);
    private bc;
    get viewportHeight(): number;
    set viewportHeight(a: number);
    private a7;
    get scrollTop(): number;
    set scrollTop(a: number);
    private a6;
    get scrollLeft(): number;
    set scrollLeft(a: number);
    private f;
    get view(): ScrollerView;
    provideContainer(a: any): void;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    provideContent(a: any): void;
    ak(a: Point, b: number, c: number): boolean;
    private t;
    get lockScrollDirection(): boolean;
    set lockScrollDirection(a: boolean);
    y: boolean;
    private aw;
    get actualVerticalScrollbarHeight(): number;
    set actualVerticalScrollbarHeight(a: number);
    private ar;
    get actualHorizontalScrollbarWidth(): number;
    set actualHorizontalScrollbarWidth(a: number);
    private c;
    get scrollbarStyle(): ScrollbarStyle;
    set scrollbarStyle(a: ScrollbarStyle);
    private az;
    get horizontalScrollbarStatus(): number;
    set horizontalScrollbarStatus(a: number);
    private ba;
    get verticalScrollbarStatus(): number;
    set verticalScrollbarStatus(a: number);
    private h;
    get horizontalAnimation(): DoubleAnimator;
    private i;
    get verticalAnimation(): DoubleAnimator;
    private bm;
    private bx;
    private bn;
    private by;
    private _executionContext;
    get executionContext(): IExecutionContext;
    set executionContext(a: IExecutionContext);
    get isVerticalActive(): boolean;
    get isHorizontalActive(): boolean;
    private _isDraggingVBar;
    get isDraggingVBar(): boolean;
    set isDraggingVBar(a: boolean);
    private _isDraggingHBar;
    get isDraggingHBar(): boolean;
    set isDraggingHBar(a: boolean);
    private q;
    private o;
    private p;
    private dr;
    private n;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    focus(): void;
    c6(a: Point): void;
    c5(a: Point): void;
    onScrolling: (sender: any, args: ScrollerScrollingEventArgs) => void;
    scrollTo(a: number, b: number): void;
    private a3;
    private a4;
    private df;
    private dg;
    private u;
    private de;
    private dk;
    private dn;
    private dl;
    private dm;
    c4(a: Point): void;
    private ct;
    private cu;
    cv(): void;
    cw(): void;
    cz(): void;
    c0(): void;
    private b3;
    private b4;
    private b5;
    private m;
    private x;
    private l;
    private w;
    private r;
    private s;
    private di;
    private dj;
    private cx;
    private cy;
}
